/*
 *   (C) Copyright IBM Corp. 2006
 *   (C) Copyright ALT Linux Ltd. 2012
 *
 *   This program is free software;  you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY;  without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program;  if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Module: LUKS
 * File: evms2/engine/plugins/luks/utils.h
 */

#define MAX_CIPHER_LEN		32
#define MAX_CIPHER_LEN_STR	"32"

#define TMP_FILE		"/tmp/cryptdevice"

#define BUF_SIZE		512
#define BUF_SECTOR_COUNT	(BUF_SIZE/EVMS_VSECTOR_SIZE)

int utils_get_luks_list(list_anchor_t *list);
int utils_set_create_object(task_context_t *context, list_anchor_t declined_objects, task_effect_t *effect);
int utils_allocate_create_option_descriptors(task_context_t *context);
int utils_get_acceptable_create_objects(task_context_t * context);
int utils_set_create_option(task_context_t *context, u_int32_t index, value_t *value, u_int32_t *UNUSED(info));
void utils_get_create_options(option_array_t *options, luks_private_data_t *pdata);
storage_object_t* utils_malloc_luks_object(void);
void utils_free_luks_object(storage_object_t *object);
boolean utils_isa_luks(storage_object_t *object);
int utils_delete_object(storage_object_t *object, list_anchor_t child_objects, boolean destroy);
int utils_create_luks(storage_object_t *object, uint commit_phase);
int utils_activate_luks(storage_object_t *object);
int utils_deactivate_luks(storage_object_t *object);
int utils_read_and_check_metadata(storage_object_t *object, luks_metadata_t *metadata);
void utils_fill_pdata_from_metadata(luks_private_data_t *pdata, luks_metadata_t *metadata);
void utils_get_devmap_info(storage_object_t *object);
